#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "zlib.h"

const char WindowsClassName[] = "TalesWeaver Packer/Unpacker";

#define FILE_Exit 1001
#define FILE_Save 1002
#define FILE_Load 1003
#define OPTIONS_Menu 2001

void Draw_to_screen(HWND hwnd);
bool recreate_hdc = false;

//Global variables for draw to screen
HDC hdc;
HDC hdcMem;
HBITMAP bitmap;

int width = 200;
int height = 200;
int BitCount = 32;
int opt = 0;

unsigned char *pImageData; //Pointer to address of image data

BITMAPFILEHEADER Bitmap_fileheader;
// BITMAPINFO structure describing the dimensions and colors of the bitmap, and an array of bytes defining the pixels of the bitmap. 
BITMAPINFO Bitmap_info; //44byte

// Step 4: the Window Procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
		//----starting application initializations--[start]--------
        case WM_CREATE:
        {
            HMENU hMenu, hSubMenu;

            hMenu = CreateMenu();

            hSubMenu = CreatePopupMenu();
			AppendMenu(hSubMenu, MF_STRING, FILE_Load, "&Unpack");
			AppendMenu(hSubMenu, MF_STRING, FILE_Save, "&Repack");
			AppendMenu(hSubMenu, MF_STRING, FILE_Exit, "E&xit");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&File");

            hSubMenu = CreatePopupMenu();
            AppendMenu(hSubMenu, MF_STRING, OPTIONS_Menu, "&None");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&Options");

            SetMenu(hwnd, hMenu);

        }
        break;
		//----starting application initializations--[end]-----------

		//----Menu options--------------------------[start]---------
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case FILE_Exit:
					{
						PostMessage(hwnd, WM_CLOSE, 0, 0);
					}

                break;

                case OPTIONS_Menu:
					{

					}

                break;

                case FILE_Load:
					{
						OPENFILENAME openfilename;
						char FileName[MAX_PATH] = "";

						ZeroMemory(&openfilename, sizeof(openfilename));

						openfilename.lStructSize = sizeof(openfilename); // SEE NOTE BELOW
						openfilename.hwndOwner = hwnd;
						openfilename.lpstrFilter = "All Files (*.*)\0*.*\0";
						openfilename.lpstrFile = FileName;
						openfilename.nMaxFile = MAX_PATH;
						openfilename.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
						openfilename.lpstrDefExt = "bmp";

						if(GetOpenFileName(&openfilename))
						{
							FILE *file, *file2;
							file = fopen(FileName, "rb");
							unsigned int file_size;
							unsigned int *file_size2 = &file_size;

							unsigned long in_size, out_size2;
							
							unsigned long* out_size = &out_size2;

							fread (file_size2, 1, 4, file);	
							in_size = file_size;
							out_size2 = 50000000;

							unsigned char *in_data = (unsigned char*) malloc (file_size);
							unsigned char *out_data = (unsigned char*) malloc (50000000);
							
							fread (in_data, 1, file_size, file);
							
							uncompress(out_data, out_size, in_data, in_size);
							fclose(file);

							file2 = fopen("Output.dat", "wb");
							fwrite(out_data, 1, out_size2, file2);
							fclose(file2);
							free (in_data);
							free (out_data);								
							opt = 1;
							fclose(file);
						}
					}

                break;

               case FILE_Save:
					{
						OPENFILENAME openfilename;
						char FileName[MAX_PATH] = "";

						ZeroMemory(&openfilename, sizeof(openfilename));

						openfilename.lStructSize = sizeof(openfilename); // SEE NOTE BELOW
						openfilename.hwndOwner = hwnd;
						openfilename.lpstrFilter = "All Files (*.*)\0*.*\0";
						openfilename.lpstrFile = FileName;
						openfilename.nMaxFile = MAX_PATH;
						openfilename.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
						openfilename.lpstrDefExt = "bmp";

						if(GetOpenFileName(&openfilename))
						{
							FILE *file, *file2;
							file = fopen(FileName, "rb");
							unsigned int file_size;
							unsigned int *file_size2 = &file_size;

							unsigned long in_size, out_size2;
							unsigned long* out_size = &out_size2;

							fseek (file, 0, SEEK_END);
							file_size=ftell (file);
							rewind(file);
							
							in_size = file_size;
							out_size2 = 50000000;

							unsigned char *in_data = (unsigned char*) malloc (file_size);
							unsigned char *out_data = (unsigned char*) malloc (50000000);
							
							fread (in_data, 1, file_size, file);
							
							compress(out_data, out_size, in_data, in_size);
							fclose(file);

							file2 = fopen("Output.dat", "wb");
							fwrite(out_size, 1, 4, file2);
							fwrite(out_data, 1, out_size2, file2);
							fclose(file2);
							free (in_data);
							free (out_data);								
							opt = 2;
							fclose(file);
						}
					}

                break;
            }
        break;
		//----Menu options--------------------------[end]-------------

	    case WM_PAINT:
		{
			//Begin Paint/ End Paint only applicable inside this WM_PAINT
	        PAINTSTRUCT ps;

	        HDC hdc = BeginPaint(hwnd, &ps);
		
			DeleteDC(hdc);

	        EndPaint(hwnd, &ps);
	    }
	    break;

        case WM_CLOSE:
            DestroyWindow(hwnd);
        break;

        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
    HWND hwnd;
    MSG Msg;

    //Step 1: Registering the Window Class
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = WindowsClassName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    // Step 2: Creating the Window
    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        WindowsClassName,
        "TalesWeaver Packer/Unpacker",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 200, 200,
        NULL, NULL, hInstance, NULL);

    if(hwnd == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

	//------Setting up the back buffering for paint [start]--------
	hdc = GetDC(hwnd); 
	hdcMem = CreateCompatibleDC(hdc); 

	//BITMAPINFO
	Bitmap_info.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	Bitmap_info.bmiHeader.biWidth = width;
	Bitmap_info.bmiHeader.biHeight = -height;
	Bitmap_info.bmiHeader.biPlanes = 1;
	Bitmap_info.bmiHeader.biBitCount = BitCount;
	Bitmap_info.bmiHeader.biCompression = BI_RGB; 
	Bitmap_info.bmiHeader.biSizeImage = width * height * (BitCount/8); //width * height *32 bit
	Bitmap_info.bmiHeader.biXPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biYPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biClrUsed = 0;
	Bitmap_info.bmiHeader.biClrImportant = 0;

	//BITMAPFILEHEADER
	Bitmap_fileheader.bfType = 0x4D42; //"BM"
	Bitmap_fileheader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)+Bitmap_info.bmiHeader.biSizeImage; //Entire file size
	Bitmap_fileheader.bfReserved1 	= 0;
	Bitmap_fileheader.bfReserved2 	= 0;
	Bitmap_fileheader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER); //start of raw image data coordinate

	bitmap = CreateDIBSection(hdc, &Bitmap_info, DIB_RGB_COLORS, (void **) &pImageData, NULL, 0);
	SelectObject(hdcMem, bitmap);

	//------Setting up the back buffering for paint [end]-----------

	unsigned int timer = 0;
	// message loop
	while(TRUE)
	{
	    // Check to see if any messages are waiting in the queue
	    while(PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE))
	    {
	        // Translate the message and dispatch it to WindowProc()
	        TranslateMessage(&Msg);
	        DispatchMessage(&Msg);
	    }

	    // If the message is WM_QUIT, exit the while loop
	    if(Msg.message == WM_QUIT)
	        break;

		if(recreate_hdc == true)
		{
			recreate_hdc = false;
			DeleteObject(bitmap);
			unsigned char *tmp_image_buffer = pImageData;
			bitmap = CreateDIBSection(hdc, &Bitmap_info, DIB_RGB_COLORS, (void **) &pImageData, NULL, 0);
			SelectObject(hdcMem, bitmap);
			memcpy (pImageData, tmp_image_buffer, width*height*4);
			free(tmp_image_buffer);	
		}

		
		if (GetTickCount() - timer >= 1000)
		{
			timer = GetTickCount();
			Draw_to_screen(hwnd);
		}
	}

	//------Removing the back buffering for paint [start]--------
	
	// Clean up - only need to do this one time as well
	DeleteDC(hdcMem);
	DeleteObject(bitmap);
	ReleaseDC(hwnd, hdc);
	
	//------Removing the back buffering for paint [end]----------
    return Msg.wParam;
}

void Draw_to_screen(HWND hwnd)
{

	RECT rect ={0,0, 200, 200};
	FillRect(hdc, &rect, (HBRUSH)(WHITE_BRUSH));
	SetTextColor(hdc, RGB(255,0,255));

	if (opt == 0) 
	{
		SetTextColor(hdc, RGB(0,255,0));
		TextOut(hdc, 50, 60, "IDLE", 4);
	}

	if (opt == 1) TextOut(hdc, 50, 60, "Unpacking...", 12);
	if (opt == 2) TextOut(hdc, 50, 60, "Repacking...", 12);
	opt = 0;
}
